#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<lli> ans(s.size(), 1e5), precalc(s.size(), 0);
    lli b = 0;
    for(lli i = 1; i < s.size(); i++)
    {
        if(s[i] < s[i-1]) ans[b] = i, b = i;
    }
    for(lli i = 0; i < s.size()-1; i++)
        if(s[i] <= s[i+1]) ans[i+1] = ans[i];
    lli t = ans[0], c = 1;
    for(lli i = 0; i < s.size(); i++)
    {
        if(t != ans[i]) precalc[i] = ++c, t = ans[i];
        else precalc[i] = c;
    }
    lli q;
    cin >> q;
    // cout << endl;
    // for(lli i = 0; i < ans.size(); i++) cout << ans[i] << " ";
    // cout << endl;
    // for(lli i = 0; i < ans.size(); i++) cout << precalc[i] << " ";
    // cout << endl;
    while(q--)
    {
        lli L, R;
        cin >> L >> R, L--, R--;
        if(L == 0) cout << precalc[R] << endl;
        else if(L-1 >= 0 && precalc[L-1] != precalc[L])
            cout << precalc[R]-precalc[L-1] << endl;
        else cout <<  precalc[R]-precalc[L-1]+1 << endl;
    }
}
